package com.dsic.gj_erp.controller.jcsj;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmDwxxp;
import com.dsic.gj_erp.service.jcsj.impl.DmDwxxpService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("dwxx")
@AllArgsConstructor
public class DmDwxxpController {

    private final DmDwxxpService dwxxpService;

    @PostMapping("addOrEdit")
    public ResultBean<?> add(@RequestBody Map<String,List<DmDwxxp>> map){
        try {
            dwxxpService.saveOrEdit(map.get("add"));
            dwxxpService.saveOrEdit(map.get("edit"));
        }catch (Exception e){
            throw new RuntimeException("同一个区域存在相同垛位号,禁止保存");
        }
        if (map.get("remove")!=null&& !map.get("remove").isEmpty()){
            map.get("remove").forEach(dwxxpService::deleteByMultiId);
        }

        return new ResultBean<>();
    }

    @PostMapping("remove")
    public ResultBean<?> remove(@RequestBody DmDwxxp dwxxp){
        dwxxpService.remove(dwxxp);
        return new ResultBean<>();
    }

    @PostMapping("list")
    public ResultBean<?> list(@RequestBody DmDwxxp dwxxp){
        List<DmDwxxp> list = dwxxpService.list(Wrappers.<DmDwxxp>lambdaQuery()
                .eq(StrUtil.isNotEmpty(dwxxp.getQy()), DmDwxxp::getQy, dwxxp.getQy())
        );
        return new ResultBean<>(list);
    }
}
