package com.dsic.gj_erp.pc.dto;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.dsic.gj_erp.bean.jhgk.DmZrcjh;
import com.dsic.gj_erp.pc.*;
import com.dsic.gj_erp.pc.dto.data.Bom;
import com.dsic.gj_erp.pc.dto.data.钢料需求;
import com.dsic.gj_erp.pc.dto.tlt.ZlType;
import com.dsic.gj_erp.pc.service.套料图工序接口;
import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;

import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.concurrent.atomic.AtomicBoolean;

import static com.dsic.gj_erp.pc.DataFactory.提取资源;

@Getter
@Setter
@Slf4j
public abstract class 套料图工序 implements 套料图工序接口 {
    protected String kw;
    protected String zl;
    protected ZlType zlType;
    protected String xzglxq;
    protected String dzglxq;
    protected 钢料需求 _钢料需求;
    protected Bom bom;
    protected double 需求数量 = 1;//默认数量为1,切割处理时候按照实际切割长度计算,切割产能在设备产能中单独计算
    protected String 需求日期;
    protected DateTime _需求日期;
    protected DateTime 参照需求日期;//当排产无法满足时,临时需求日期生效,±3天查找可用资源
    protected DmZrcjh 中日程;
    protected List<Constant.工序> 工序;
    protected Map<Constant.工序,工序CD> 工序CD;
    protected AtomicBoolean fail;
    protected List<订货计划> 订货计划s;

    public void run(){
        fail=new AtomicBoolean(false);
        if (基础设置()){
            this.run(fail);
        }
    }

    protected boolean 基础设置(){
        if (ObjUtil.isEmpty(this.bom)||StrUtil.isEmpty(this.bom.getTzbh())){
            return false;
        }

        String xzxq=this.xzglxq;
        if (this.参照需求日期!=null){
            xzxq=this.参照需求日期.toString("yyyy/MM/dd");
        }

        //为了批次完整性,目前无论大小组都采用小组需求期
        this.set需求日期(xzxq);

        if (this.zlType==ZlType.小组||this.zlType==ZlType.焊接机器人肘板){
            this.set需求日期(xzxq);
        }

        if (this.zlType==ZlType.大组){
            if (this.dzglxq==null){
                this.set需求日期(xzxq);
                this.bom.缺少大组需求期使用小组需求替代();
            }else {
                this.set需求日期(this.dzglxq);
            }
        }

        if (this.zlType==ZlType.大组&&this.工序.contains(Constant.工序.曲型)){
//            大组需求有曲外板,需要按照大组需求期计算
            if (this.dzglxq==null){
                this.set需求日期(xzxq);
            }else {
                this.set需求日期(this.dzglxq);
            }
            //曲外板批量名称设置.
            this.bom.set_pl(this.bom.getPl()+"Q");
        }

        //当大组需求期无法满足小组需求时,以小组需求期为准
        if (StrUtil.isAllNotEmpty(xzxq,dzglxq)){
            if (DateUtil.parse(xzxq,"yyyy/MM/dd").isAfter(DateUtil.parse(dzglxq,"yyyy/MM/dd"))){
                this.set需求日期(dzglxq);
            }
        }

        this._需求日期 = DateUtil.parse(this.需求日期, "yyyy/MM/dd");

        this.订货计划s = DataFactory.获取订货计划(bom.getDcch());

        return true;
    }

    public void run(AtomicBoolean atomicBoolean) {
        if (!this.订货()){
            bom.没有订货();
        }

        this.工序.forEach(_工序 -> {
            资源 _资源 = this.占用资源2(_工序, 需求数量);

            if (_工序==Constant.工序.上料&&!this.到货(_资源)){
                this.bom.上料之前无法到货();
                //使用中日程定义需求日期
                if (this.中日程==null){
                    this.bom.缺少中日程();
                    return;
                }
                if (this.zlType==ZlType.小组&&this.中日程.getGjjsXz()==null){
                    this.bom.中日期无小组需求期();
                    return;
                }
                if (this.zlType==ZlType.大组&&this.中日程.getGjjsDz()==null){
                    this.bom.中日程无大组需求期();
                    return;
                }
                this._需求日期=this.zlType==ZlType.小组?DateUtil.parse(this.中日程.getGjjsXz()):DateUtil.parse(this.中日程.getGjjsDz());
                //再次计算上料日期
                this.占用资源2(_工序, 需求数量);
            }

            //只有大组需求期时,坡口结束日期需满足大组结束日期
            if (StrUtil.isEmpty(xzglxq)&&StrUtil.isNotEmpty(dzglxq)&&_工序==Constant.工序.坡口){
                if (this.中日程!=null){
                    String 大组结束日期=this.中日程.getGjjsDz();
                    if (DateUtil.parse(大组结束日期).isBefore(DateUtil.parse(_资源.getDate()))){
                        this.bom.坡口结束日期不满足大组需求期();
                        atomicBoolean.set(true);
                    }
                }
            }
        });

        //排产失败相关记录
        if (bom.get已排工序().size()!=this.工序.size()) {
            Manager.排产结果.add(this.bom);
            atomicBoolean.set(true);
        }
    }

    protected boolean 订货(){
        AtomicBoolean 是否订货=new AtomicBoolean(false);
        if (ObjUtil.isEmpty(订货计划s)){
            return 是否订货.get();
        }

        订货计划s.forEach(item->{
            if (item.getPlList().contains(bom.getPl())){
                是否订货.set(true);
            }
        });

        return 是否订货.get();
    }

    protected boolean 到货(资源 _资源){
        AtomicBoolean 能否到货=new AtomicBoolean(false);
        if (ObjUtil.isNotEmpty(订货计划s)){
            订货计划s.forEach(item->{
                if (item.getPlList().contains(bom.getPl())){
                    DateTime arriveDate;
                    try {
                        arriveDate=DateUtil.parse(item.getAllArriveData(),"yyyy/MM/dd");
                    }catch (Exception e){
                        this.bom.订货计划到齐日期格式错误();
                        log.error("上料计划时间格式错误--月份:{},船号:{},批次范围:{},到齐日期:{}",item.getMonth(),item.getDcch(),item.getPls(),item.getAllArriveData());
                        return;
                    }
                    if (_资源.get_date().isAfter(arriveDate)){
                        能否到货.set(true);
                    }
                }
            });
        }
        return 能否到货.get();
    }

    protected 资源 占用资源2(Constant.工序 _工序,double 需求数量){
        Integer cd = 工序CD.get(_工序).getCd();
        DateTime dateTime = DateUtil.offsetDay(this._需求日期, cd);
        资源 _资源 = 提取资源(dateTime);
        try {
            if (_资源.占用资源(_工序,this.bom,需求数量)){
//                this.bom.set所在资源(_资源);
                this.bom.get已排工序().add(0,_工序);
            }
        }catch (Exception e){
            e.printStackTrace();
            throw e;
        }

        return _资源;
    }

    protected boolean 占用资源(Constant.工序 _工序,double 需求数量){
        Integer cd = 工序CD.get(_工序).getCd();
        DateTime dateTime = DateUtil.offsetDay(this._需求日期, cd);
        资源 _资源 = 提取资源(dateTime);
        AtomicBoolean 占用成功=new AtomicBoolean(false);
        try {
            if (_资源.占用资源(_工序,this.bom,需求数量)){
//                this.bom.set所在资源(_资源);
                this.bom.get已排工序().add(0,_工序);
                占用成功.set(true);
            }
        }catch (Exception e){
            e.printStackTrace();
        }

        return 占用成功.get();
    }

    protected boolean 已占资源(Constant.工序 _工序,String 套料图){
        资源 已占资源 = 资源.读取套料图所在资源(套料图);
        工序产能 工序产能 = null;
        if (已占资源 != null) {
            工序产能 = 已占资源.get工序产能MAP().get(_工序);
        }
        if (工序产能 != null && 工序产能.get资源占用图纸表().contains(bom.getTzbh())) {
            bom.set所在资源(已占资源);
            Optional<设备> _设备 = 工序产能.获取已占用设备(bom.getTzbh());
            _设备.ifPresent(bom::set所在设备);
            return true;
        }
        return false;
    }

    @Override
    public 套料图工序 钢料需求(钢料需求 _钢料需求) {
        this._钢料需求=_钢料需求;
        return this;
    }

    public boolean getSuccess(){
        return this.fail.get();
    }

}
