package com.dsic.gj_erp.service.jcsj.impl;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jcsj.vo.BomVO;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.mapper.jcsj.DmBomMapper;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-25
 */
@Service
public class DmBomServiceImpl extends ServiceImpl<DmBomMapper, DmBom> implements DmBomService {

    @Autowired
    BomUploadServiceImpl bomUploadService;
    @Autowired
    DmBomMapper dmBomMapper;

    public List<DmBom> getBomWithYlbs(String dcCh,String dcPl){
        return dmBomMapper.getBomWithYlbs(dcCh,dcPl);
    }
    @Override
    public List<BomVO> getListBom(HttpServletRequest req,Map map) throws CustomException {
//        if(map.get("zt").equals("01")){
            List<BomVO> dmBoms = bomUploadService.insertBom(req, (String) map.get("dcch"), (String) map.get("dcpl"),"02");
            return dmBoms;
//            return  dmBoms;
//        }else{
//            List<DmBom> list = this.list(new QueryWrapper<DmBom>().eq("sjch", map.get("dcch"))
//                .eq(StrUtil.isNotEmpty((String) map.get("fd")), "fd", map.get("dcfd"))
//                .eq(StrUtil.isNotEmpty((String) map.get("pl")), "fd", map.get("dcpl"))
//                .eq(StrUtil.isNotEmpty((String) map.get("zt")), "zt", map.get("zt"))
//            );
//            return list;
//        }



//        if(list.size()<=0){
//
//            throw new CustomException(10105, "改bom尚未提交 请点击生成bom 查看数据");
//        }

    }

    public List<DmBom> getListBomRealy(HttpServletRequest req,Map map) throws CustomException {

//            return  dmBoms;
//        }else{
            List<DmBom> list = this.list(new QueryWrapper<DmBom>().eq("dcch", map.get("dcch"))
                .eq(StrUtil.isNotEmpty((String) map.get("fd")), "fd", map.get("dcfd"))
                .eq(StrUtil.isNotEmpty((String) map.get("dcpl")), "pl", map.get("dcpl"))
                .eq(StrUtil.isNotEmpty((String) map.get("type")), "type", map.get("type"))
                .orderBy(true,true,"pl","fd","type","tzbh","ljbh")
            );
            return list;
//        }



//        if(list.size()<=0){
//
//            throw new CustomException(10105, "改bom尚未提交 请点击生成bom 查看数据");
//        }

    }

    @Override
    public void insertBoms(List<DmBom> map) throws CustomException {
//        dmBomMapper.insertBoms(map);
        this.saveBatch(map,1000);
//        List<List<DmBom>> partition = ListUtil.partition(map, 50);
//        for (List<DmBom> users : partition) {
//            dmBomMapper.insertBoms(users);
//        }

//        map.forEach(e->{
//            if(StringUtils.isBlank(e.getZt())){
//                e.setZt("02");
//                dmBomMapper.insertBom(e);
//            }
//
//        });

    }

    @Override
    public void copyListBom(HttpServletRequest req, Map map) {
        String dcch=(String) map.get("dcch");
        String mbch=(String) map.get("mbch");
        List<DmBom> list=(List<DmBom>)map.get("list");
        String str= JSON.toJSONString(list);
        list= JSONObject.parseArray(str, DmBom.class);
      //  List<DmBom> list= this.list(new QueryWrapper<DmBom>().eq("dcch",dcch));
        list.forEach(e->{
            e.setMbch(e.getDcch());
            e.setDcch(mbch);
            e.setSjch("");
            e.setId(null);
            e.setYidd(e.getIdd());
            e.setIdd(IdWorker.get32UUID());

        });
        this.saveBatch(list,1000);
        //this.saveBatch()
    }
}
